diff --git a/linux-user/aarch64/syscall_nr.h b/linux-user/aarch64/syscall_nr.h
index 12ef002d60f9..c2e09ed5c50c 100644
--- a/linux-user/aarch64/syscall_nr.h
+++ b/linux-user/aarch64/syscall_nr.h
@@ -305,9 +305,26 @@
 #define TARGET_NR_process_madvise 440
 #define TARGET_NR_epoll_pwait2 441
 #define TARGET_NR_mount_setattr 442
+#define TARGET_NR_quotactl_fd 443
 #define TARGET_NR_landlock_create_ruleset 444
 #define TARGET_NR_landlock_add_rule 445
 #define TARGET_NR_landlock_restrict_self 446
-#define TARGET_NR_syscalls 447
+#define TARGET_NR_memfd_secret 447
+#define TARGET_NR_process_mrelease 448
+#define TARGET_NR_futex_waitv 449
+#define TARGET_NR_set_mempolicy_home_node 450
+#define TARGET_NR_cachestat 451
+#define TARGET_NR_fchmodat2 452
+#define TARGET_NR_map_shadow_stack 453
+#define TARGET_NR_futex_wake 454
+#define TARGET_NR_futex_wait 455
+#define TARGET_NR_futex_requeue 456
+#define TARGET_NR_statmount 457
+#define TARGET_NR_listmount 458
+#define TARGET_NR_lsm_get_self_attr 459
+#define TARGET_NR_lsm_set_self_attr 460
+#define TARGET_NR_lsm_list_modules 461
+#define TARGET_NR_mseal 462
+#define TARGET_NR_syscalls 463
 
 #endif /* LINUX_USER_AARCH64_SYSCALL_NR_H */
diff --git a/linux-user/hexagon/syscall_nr.h b/linux-user/hexagon/syscall_nr.h
index b047dbbf6df3..f3220b74f7c3 100644
--- a/linux-user/hexagon/syscall_nr.h
+++ b/linux-user/hexagon/syscall_nr.h
@@ -90,7 +90,7 @@
 #define TARGET_NR_sync 81
 #define TARGET_NR_fsync 82
 #define TARGET_NR_fdatasync 83
-#define TARGET_NR_sync_file_range 84
+#define TARGET_NR_sync_file_range2 84
 #define TARGET_NR_timerfd_create 85
 #define TARGET_NR_timerfd_settime 86
 #define TARGET_NR_timerfd_gettime 87
@@ -324,9 +324,25 @@
 #define TARGET_NR_process_madvise 440
 #define TARGET_NR_epoll_pwait2 441
 #define TARGET_NR_mount_setattr 442
+#define TARGET_NR_quotactl_fd 443
 #define TARGET_NR_landlock_create_ruleset 444
 #define TARGET_NR_landlock_add_rule 445
 #define TARGET_NR_landlock_restrict_self 446
-#define TARGET_NR_syscalls 447
+#define TARGET_NR_process_mrelease 448
+#define TARGET_NR_futex_waitv 449
+#define TARGET_NR_set_mempolicy_home_node 450
+#define TARGET_NR_cachestat 451
+#define TARGET_NR_fchmodat2 452
+#define TARGET_NR_map_shadow_stack 453
+#define TARGET_NR_futex_wake 454
+#define TARGET_NR_futex_wait 455
+#define TARGET_NR_futex_requeue 456
+#define TARGET_NR_statmount 457
+#define TARGET_NR_listmount 458
+#define TARGET_NR_lsm_get_self_attr 459
+#define TARGET_NR_lsm_set_self_attr 460
+#define TARGET_NR_lsm_list_modules 461
+#define TARGET_NR_mseal 462
+#define TARGET_NR_syscalls 463
 
 #endif /* LINUX_USER_HEXAGON_SYSCALL_NR_H */
diff --git a/linux-user/loongarch64/syscall_nr.h b/linux-user/loongarch64/syscall_nr.h
index be00915adf22..fefca6f5f6d3 100644
--- a/linux-user/loongarch64/syscall_nr.h
+++ b/linux-user/loongarch64/syscall_nr.h
@@ -307,6 +307,18 @@
 #define TARGET_NR_process_mrelease 448
 #define TARGET_NR_futex_waitv 449
 #define TARGET_NR_set_mempolicy_home_node 450
-#define TARGET_NR_syscalls 451
+#define TARGET_NR_cachestat 451
+#define TARGET_NR_fchmodat2 452
+#define TARGET_NR_map_shadow_stack 453
+#define TARGET_NR_futex_wake 454
+#define TARGET_NR_futex_wait 455
+#define TARGET_NR_futex_requeue 456
+#define TARGET_NR_statmount 457
+#define TARGET_NR_listmount 458
+#define TARGET_NR_lsm_get_self_attr 459
+#define TARGET_NR_lsm_set_self_attr 460
+#define TARGET_NR_lsm_list_modules 461
+#define TARGET_NR_mseal 462
+#define TARGET_NR_syscalls 463
 
 #endif /* LINUX_USER_LOONGARCH_SYSCALL_NR_H */
diff --git a/linux-user/openrisc/syscall_nr.h b/linux-user/openrisc/syscall_nr.h
index f7faddb54c58..2b66f99ea66a 100644
--- a/linux-user/openrisc/syscall_nr.h
+++ b/linux-user/openrisc/syscall_nr.h
@@ -326,9 +326,25 @@
 #define TARGET_NR_process_madvise 440
 #define TARGET_NR_epoll_pwait2 441
 #define TARGET_NR_mount_setattr 442
+#define TARGET_NR_quotactl_fd 443
 #define TARGET_NR_landlock_create_ruleset 444
 #define TARGET_NR_landlock_add_rule 445
 #define TARGET_NR_landlock_restrict_self 446
-#define TARGET_NR_syscalls 447
+#define TARGET_NR_process_mrelease 448
+#define TARGET_NR_futex_waitv 449
+#define TARGET_NR_set_mempolicy_home_node 450
+#define TARGET_NR_cachestat 451
+#define TARGET_NR_fchmodat2 452
+#define TARGET_NR_map_shadow_stack 453
+#define TARGET_NR_futex_wake 454
+#define TARGET_NR_futex_wait 455
+#define TARGET_NR_futex_requeue 456
+#define TARGET_NR_statmount 457
+#define TARGET_NR_listmount 458
+#define TARGET_NR_lsm_get_self_attr 459
+#define TARGET_NR_lsm_set_self_attr 460
+#define TARGET_NR_lsm_list_modules 461
+#define TARGET_NR_mseal 462
+#define TARGET_NR_syscalls 463
 
 #endif /* LINUX_USER_OPENRISC_SYSCALL_NR_H */
diff --git a/linux-user/riscv/syscall32_nr.h b/linux-user/riscv/syscall32_nr.h
index 412e58e5b2f2..42376ac8c7d2 100644
--- a/linux-user/riscv/syscall32_nr.h
+++ b/linux-user/riscv/syscall32_nr.h
@@ -7,6 +7,8 @@
 #define LINUX_USER_RISCV_SYSCALL32_NR_H
 
 #define TARGET_NR_io_setup 0
+#define TARGET_NR_riscv_flush_icache (TARGET_NR_arch_specific_syscall + 15)
+#define TARGET_NR_riscv_hwprobe (TARGET_NR_arch_specific_syscall + 14)
 #define TARGET_NR_io_destroy 1
 #define TARGET_NR_io_submit 2
 #define TARGET_NR_io_cancel 3
@@ -227,8 +229,6 @@
 #define TARGET_NR_perf_event_open 241
 #define TARGET_NR_accept4 242
 #define TARGET_NR_arch_specific_syscall 244
-#define TARGET_NR_riscv_flush_icache (TARGET_NR_arch_specific_syscall + 15)
-#define TARGET_NR_riscv_hwprobe (TARGET_NR_arch_specific_syscall + 14)
 #define TARGET_NR_prlimit64 261
 #define TARGET_NR_fanotify_init 262
 #define TARGET_NR_fanotify_mark 263
@@ -300,9 +300,26 @@
 #define TARGET_NR_process_madvise 440
 #define TARGET_NR_epoll_pwait2 441
 #define TARGET_NR_mount_setattr 442
+#define TARGET_NR_quotactl_fd 443
 #define TARGET_NR_landlock_create_ruleset 444
 #define TARGET_NR_landlock_add_rule 445
 #define TARGET_NR_landlock_restrict_self 446
-#define TARGET_NR_syscalls 447
+#define TARGET_NR_memfd_secret 447
+#define TARGET_NR_process_mrelease 448
+#define TARGET_NR_futex_waitv 449
+#define TARGET_NR_set_mempolicy_home_node 450
+#define TARGET_NR_cachestat 451
+#define TARGET_NR_fchmodat2 452
+#define TARGET_NR_map_shadow_stack 453
+#define TARGET_NR_futex_wake 454
+#define TARGET_NR_futex_wait 455
+#define TARGET_NR_futex_requeue 456
+#define TARGET_NR_statmount 457
+#define TARGET_NR_listmount 458
+#define TARGET_NR_lsm_get_self_attr 459
+#define TARGET_NR_lsm_set_self_attr 460
+#define TARGET_NR_lsm_list_modules 461
+#define TARGET_NR_mseal 462
+#define TARGET_NR_syscalls 463
 
 #endif /* LINUX_USER_RISCV_SYSCALL32_NR_H */
diff --git a/linux-user/riscv/syscall64_nr.h b/linux-user/riscv/syscall64_nr.h
index 29e1eb20753e..96ee92ec31f8 100644
--- a/linux-user/riscv/syscall64_nr.h
+++ b/linux-user/riscv/syscall64_nr.h
@@ -7,6 +7,8 @@
 #define LINUX_USER_RISCV_SYSCALL64_NR_H
 
 #define TARGET_NR_io_setup 0
+#define TARGET_NR_riscv_flush_icache (TARGET_NR_arch_specific_syscall + 15)
+#define TARGET_NR_riscv_hwprobe (TARGET_NR_arch_specific_syscall + 14)
 #define TARGET_NR_io_destroy 1
 #define TARGET_NR_io_submit 2
 #define TARGET_NR_io_cancel 3
@@ -250,8 +252,6 @@
 #define TARGET_NR_accept4 242
 #define TARGET_NR_recvmmsg 243
 #define TARGET_NR_arch_specific_syscall 244
-#define TARGET_NR_riscv_flush_icache (TARGET_NR_arch_specific_syscall + 15)
-#define TARGET_NR_riscv_hwprobe (TARGET_NR_arch_specific_syscall + 14)
 #define TARGET_NR_wait4 260
 #define TARGET_NR_prlimit64 261
 #define TARGET_NR_fanotify_init 262
@@ -306,9 +306,26 @@
 #define TARGET_NR_process_madvise 440
 #define TARGET_NR_epoll_pwait2 441
 #define TARGET_NR_mount_setattr 442
+#define TARGET_NR_quotactl_fd 443
 #define TARGET_NR_landlock_create_ruleset 444
 #define TARGET_NR_landlock_add_rule 445
 #define TARGET_NR_landlock_restrict_self 446
-#define TARGET_NR_syscalls 447
+#define TARGET_NR_memfd_secret 447
+#define TARGET_NR_process_mrelease 448
+#define TARGET_NR_futex_waitv 449
+#define TARGET_NR_set_mempolicy_home_node 450
+#define TARGET_NR_cachestat 451
+#define TARGET_NR_fchmodat2 452
+#define TARGET_NR_map_shadow_stack 453
+#define TARGET_NR_futex_wake 454
+#define TARGET_NR_futex_wait 455
+#define TARGET_NR_futex_requeue 456
+#define TARGET_NR_statmount 457
+#define TARGET_NR_listmount 458
+#define TARGET_NR_lsm_get_self_attr 459
+#define TARGET_NR_lsm_set_self_attr 460
+#define TARGET_NR_lsm_list_modules 461
+#define TARGET_NR_mseal 462
+#define TARGET_NR_syscalls 463
 
 #endif /* LINUX_USER_RISCV_SYSCALL64_NR_H */